#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "ticket.h"

int main(int argc, char* argv[])
{
    FILE* ticket_output = stdout;

    /* Exercice 4 : on peut préciser comme paramètre du programme si on
     * souhaite que les tickets soient écrits dans un fichier.
     */
    if (argc == 2)
    {
        ticket_output = fopen(argv[1], "a");
        if (ticket_output == NULL)
        {
            perror("Erreur à l'ouverture du fichier:");
            return EXIT_FAILURE;
        }

    }
    printf("===========\n");
    printf("Ticket vide\n");

    struct ticket_s* ticket = ticket_nouveau();

    ticket_afficher(ticket, ticket_output);

    ticket_detruire(ticket);


    printf("===========\n");
    printf("Ticket avec 1 élément\n");

    ticket = ticket_nouveau();

    ticket_ajoute_item(ticket, BOISSON, "Bouteille d'eau", 0.90);

    ticket_afficher(ticket, ticket_output);

    ticket_detruire(ticket);


    printf("===========\n");
    printf("Ticket standard\n");

    ticket = ticket_nouveau();

    ticket_ajoute_item(ticket, ENTREE, "Carottes râpées", 0.90);
    ticket_ajoute_item(ticket, PLAT, "Steak", 3.55);
    ticket_ajoute_item(ticket, PLAT, "Frites", 2.10);
    ticket_ajoute_item(ticket, FROMAGE, "Camembert", 0.70);
    ticket_ajoute_item(ticket, DESSERT, "Salade de fruits", 0.70);

    ticket_afficher(ticket, ticket_output);

    ticket_detruire(ticket);


    printf("===========\n");
    printf("Ticket avec suppressions\n");

    ticket = ticket_nouveau();

    ticket_ajoute_item(ticket, ENTREE, "Carottes râpées", 0.90);
    ticket_ajoute_item(ticket, PLAT, "Steak", 3.55);
    ticket_ajoute_item(ticket, PLAT, "Frites", 2.10);
    assert(ticket_supprime_item(ticket, 0));
    ticket_ajoute_item(ticket, FROMAGE, "Camembert", 0.70);
    ticket_ajoute_item(ticket, DESSERT, "Salade de fruits", 0.70);
    assert(ticket_supprime_item(ticket, 2));
    assert(ticket_supprime_item(ticket, 2));

    ticket_afficher(ticket, ticket_output);

    ticket_detruire(ticket);


    printf("===========\n");
    printf("Ticket avec trop d'éléments\n");

    ticket = ticket_nouveau();

    for (int i = 0; i < 20; i++)
    {
        ticket_ajoute_item(ticket, PLAT, "Frites", 2.10);
    }

    ticket_afficher(ticket, ticket_output);

    ticket_detruire(ticket);

    if (ticket_output != stdout)
    {
        fclose(ticket_output);
    }

    return EXIT_SUCCESS;
}
